## org.apache.http.nio.entity
Interface HttpAsyncContentProducer

All Superinterfaces:
  Closeable

All Known Implementing Classes:
  EntityAsyncContentProducer, NByteArrayEntity, NFileEntity, NStringEntity

    public interface HttpAsyncContentProducer

extends Closeable

`HttpAsyncContentProducer` is a callback interface whose methods get invoked to stream out message content to a non-blocking HTTP connection.

Since:
  4.2

Method Summary
`boolean` `isRepeatable()` Determines whether or not this producer is capable of producing its content more than once.
`void` `produceContent(ContentEncoder encoder, IOControl ioctrl)` Invoked to write out a chunk of content to the `ContentEncoder`.

Methods inherited from interface java.io.Closeable
`close`

Method Detail

### produceContent

    void produceContent(ContentEncoder encoder,
                        IOControl ioctrl)
                        throws IOException

  Invoked to write out a chunk of content to the `ContentEncoder`. The `IOControl` interface can be used to suspend output event notifications if the entity is temporarily unable to produce more content.

  When all content is finished, the producer MUST call `ContentEncoder.complete()`. Failure to do so may cause the entity to be incorrectly delimited.

  Please note that the `ContentEncoder` object is not thread-safe and should only be used within the context of this method call. The `IOControl` object can be shared and used on other thread to resume output event notifications when more content is made available.

  Parameters:
    `encoder` - content encoder.
    `ioctrl` - I/O control of the underlying connection.
  Throws:
    `IOException`

### isRepeatable

    boolean isRepeatable()

  Determines whether or not this producer is capable of producing its content more than once. Repeatable content producers are expected to be able to recreate their content even after having been closed.

Copyright © 2005-2013 The Apache Software Foundation. All Rights Reserved.